#include "globals.h"
#include "datastructures.h"
#include "correction_terms.h"
#include <assert.h>
#include <stdlib.h>
#include "frequent_linear/RMQ_n_1_alstrup.hpp"

extern int overshoot;

int *calculate_c(database *D) {
        int i, j, l, nl, nwords, SA, *C, *last;
		FILE *sa_file;
        assert(D != NULL && D->a != NULL && D->T != NULL && D->SA != NULL && D->lcp != NULL);
		RMQ_n_1_alstrup rmq(D->lcp, D->n);
        /* use D->a to store word index for each position */
        nwords = 0;
        for (i=0; i<D->n; ++i) {
                D->a[i] = nwords;
                if (D->T[i] == SEPARATOR)
                        ++nwords;
        }
		my_msync(D->T, D->n + overshoot);
		my_munmap(D->T, D->n + overshoot);
		D->T = NULL;
		my_msync(D->SA, D->n * sizeof(int));
		my_munmap(D->SA, D->n * sizeof(int));
		D->SA = NULL;
		sa_file = fopen(D->sa_filename, "r");
		if (sa_file == NULL)
				fatal_error("could not open SA file");
        C = my_calloc(D->n, sizeof(int));
		/* use array b as last */
		D->b_fd = open_truncate("b_", D->db_name, D->b_filename, D->n * sizeof(int));
		D->b = my_mmap(D->b_fd, D->n * sizeof(int), MAP_SHARED);
        last = D->b;
        l = -1;
        for (j=0; j<D->n; ++j) {
				fread(&SA, 4, 1, sa_file);
                i = D->a[ SA ];
                if (last[i] > 0) {
						nl = rmq.query(last[i], j);
                        ++C[nl];
                }
                last[i] = j + 1;
        }
		fclose(sa_file);
        return C;
}
