#ifndef _datastructures_h_
#define _datastructures_h_

typedef struct datab {
	unsigned char *T;       /* text */
	int *SA;                /* suffix array */
	int *lcp;               /* lcp array */
	int *a, *b;             /* results interval */
	int n;                  /* length of T */
	int stack_size;         /* stack size needed for traversal of lcp interval tree */
	int minf, maxf;         /* frequency thresholds */
	int t_fd;               /* file descriptor of the text file */
	char db_name[100];      /* file name of the database file */
	char t_filename[100];    /* file descriptor of the text file */
	int lcp_fd;             /* file descriptor of the lcp table file */
	char lcp_filename[100];  /* file name of the lcp table */
	int a_fd;               /* file descriptor of the a array file */
	char a_filename[100];    /* file name of the a array */
	int b_fd;               /* file descriptor of the b array file */
	char b_filename[100];    /* file name of the b array */
	int sa_fd;              /* file descriptor of the SA */
	char sa_filename[100];   /* file name of the SA */
	char merge_filename[100];/* file name for results lists */
	int *c;                 /* number of suffixes in order between suffix i-1 and i */
	int c_fd;               /* file descriptor of c */
	char c_filename[100];    /* file name of c */
	int *l;                 /* length of longest common prefix when matching */
	int l_fd;               /* file descriptor of l */
	char l_filename[100];    /* file name of l */
	int *sl, *sr;           /* suffix links */
	union child *childtab;  /* child table */
	int sl_fd, sr_fd;       /* file descriptors of suffix links */
	int ch_fd;              /* file descriptor of childtab */
	char sl_filename[100];   /* file names of suffix links */
	char sr_filename[100];
	char ch_filename[100];   /* file name of child table */
}database;

union child {
	int nextl, up, down;
};

void delete_database(database *D);
void close_database(database *D);
void print_results(database *D);

void create_childtab(database *D);
int get_first_l_index(union child *childtab, int left, int right);
int get_interval_starting_with(database *D, int left, int right, unsigned char c, int *cleft, int *cright);

void calculate_suffixlinks(database *D);

void do_match(database *D, unsigned char *T, int n);

#endif
