#include "globals.h"
#include "datastructures.h"
#include "extract.h"
#include <assert.h>
#include <stdlib.h>

void extract_relevant_substrings(database *D, int *C) {
	int i, *l, len, left, freq, SA, lcp;
	FILE *sa_file;
	sa_file = fopen(D->sa_filename, "r");
	if (sa_file == NULL)
		fatal_error("could not open SA file");
	/* convert C' to array C'' */
	for (i=1; i<D->n; ++i)
		C[i] += C[i-1];
	l = my_malloc(sizeof(int) * D->n);
	l[0] = 0;
	len = 1;
	for (i=1; i<=D->n; ++i) {
		fread(&SA, 4, 1, sa_file);
		l[len] = i-1;
		lcp = D->n - SA + 1;
		++len;
		left = i-1;
		D->a[i-1] = D->n+2;
		while(len > 1 && (i == D->n || lcp > D->lcp[i])) {
			left = l[--len];
			freq = i - left - (C[i-1]-C[left]);
			if (D->minf <= freq && freq <= D->maxf) {
				if (D->a[left] == D->n+2)
						D->b[left] = lcp;
				D->a[left] = MAX(D->lcp[left], D->lcp[i]) + 1;
			}
			lcp = D->lcp[left];
		}
		if (i < D->n && lcp < D->lcp[i]) {
			l[len] = left;
			++len;
		}
	}
	my_free(l, D->n * sizeof(int));
	fclose(sa_file);
	D->T = (unsigned char *)my_mmap(D->t_fd, D->n, MAP_PRIVATE);
	for (i=len=D->n-1; i>=0; --i) {
		if (D->T[i] == SEPARATOR)
			len = i;
		C[i] = len - i;
	}
	my_munmap(D->T, D->n);
	D->T = NULL;
	D->SA = my_mmap(D->sa_fd, D->n * sizeof(int), MAP_PRIVATE);
	for (i=0; i<D->n; ++i)
		D->b[i] = MIN(D->b[i], C[D->SA[i]]);
}
