#ifndef _frequent_linear_hpp_
#define _frequent_linear_hpp_

#include "SAfor2DBnaive.hpp"
#include "LCPmanzini.hpp"
#include "RMQ_n_1_alstrup.hpp"
#include <stdlib.h>
#include <iostream>
#include <stdio.h>
#include <stack>
#include <vector>

using namespace std;

class Node { // a (virtual) node in the (virtual) suffix tree:
public:
  int l;  // start-position in string
  int h;  // depth
  int s1; // number of leaves from DB1 in subtree
  int s2; // number of leaves from DB2 in subtree
  int c1; // correction factor for DB1
  int c2; // correction factor for DB2

  Node(int, int, int, int, int = 0, int = 0);
};

/** 
 * Calculates frequent substrings with the optimal method.
 */
class FrequentStringsLinear {
public:
  // returns all strings that occurr >= min times in db1 and <= max times in db2
  void frequent(char*, char*, int, int, int);

  // print string t[SA[p]..SA[p] + l - 1]
  void print(int*, unsigned char*, int, int);
};

#endif
