#include "manzini.hpp"
#include "SAfor2DBnaive.hpp"

/**
 * NOTE: before calling this procedure, make sure to have called
 * the overshoot-value by init_ds_ssort() and allocate the size
 * of t large enough to contain the text PLUS overshoot characters!
 */
int* ConstructSAmanzini::construct(unsigned char* text, int length, int** inverse) {
  int* Pos;

  Pos = (int*) malloc(sizeof(int) * length);
  change_mem(4LL * length);
  if (Pos == 0) goto out;

  // now the Pos is allocated => construct the SA!
  ds_ssort(text, Pos, length);

 out:
  if (inverse != NULL && Pos != NULL) {
	// create the inverse array and store it in 'prm'
	int* prm;
	prm = (int*) malloc(sizeof(int) * length);
        change_mem(4LL * length);
	if (prm == 0) *inverse = NULL; // not enough memory
	else {
	  for (int i = 0; i < length; i++) prm[Pos[i]] = i;
	  *inverse = prm;
	}
  }

  return Pos;
}
