/* Constructs SA with Manzini and Ferragina's method. */
#ifndef _manzini_hpp_
#define _manzini_hpp_

#include "constructSA.hpp"
extern "C"{
#include "../manzini/ds_ssort.h"
}
#include <stdlib.h>
#include <iostream>
using namespace std;

/** 
 * Constructs SA with Manzini and Ferragina's method.
*/
class ConstructSAmanzini : public ConstructSA {
public:
  /**
   * NOTE: before calling this procedure, make sure to have called
   * the overshoot-value by init_ds_ssort() and allocate the size
   * of t large enough to contain the text PLUS overshoot characters!
   */
  virtual int* construct(unsigned char* t, int length, int** inverse = NULL);
};

#endif
