#include "merge.h"
#include "globals.h"
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/mman.h>
#include <string.h>

void merge(database *D1, database *D2) {
	int p1, p2, lcp, lcp2 = -1, mlcp = 0, mlcp2 = 0, a_out = D1->n+1, b_out = 0, a_out2 = a_out, b_out2 = b_out, c;
	FILE *inp, *inp2;
	assert(D1 != NULL && D1->lcp != NULL && D1->a != NULL && D1->b != NULL);
	assert(D2 != NULL && D2->a != NULL && D2->b != NULL);
	inp = fopen("merge.tmp", "r");
	if (inp == NULL)
		fatal_error("could not open merge.tmp");
	inp2 = fopen(D1->c_filename, "r");
	if (inp2 == NULL)
		fatal_error("could not open file containing c");
	assert(D1->minf > 0);
	for (p1=D1->n,p2=D2->n-1; p1 > 0; --p1) {
		fread(&c, 4, 1, inp2);
		while(c--) {
			assert(p2 >= 0);
			fread(&lcp, 4, 1, inp);
			if (lcp > D2->n) {
				lcp -= (D2->n+1);
				if (p1 < D1->n)
					lcp2 = D1->lcp[p1];
			}
			else {
				lcp2 = lcp;
				assert(p1 < D1->n);
				lcp = D1->lcp[p1];
			}
			mlcp2 = MAX(mlcp2, lcp2);
			mlcp = MAX(mlcp, lcp);
			if (p1 < D1->n)
				assert(lcp >= D1->lcp[p1] && lcp2 >= D1->lcp[p1]);
			if (D2->a[p2] <= D2->b[p2]) {
				if (lcp >= D2->a[p2]) {
					assert(MAX(a_out, D2->a[p2]) > MIN(b_out, MIN(lcp, D2->b[p2])));
					a_out = MIN(a_out, D2->a[p2]);
					b_out = MAX(b_out, MIN(lcp, D2->b[p2]));
				}
				if (lcp2 >= D2->a[p2]) {
					assert(MAX(a_out2, D2->a[p2]) > MIN(b_out2, MIN(lcp2, D2->b[p2])));
					a_out2 = MIN(a_out2, D2->a[p2]);
					b_out2 = MAX(b_out2, MIN(lcp2, D2->b[p2]));
				}
			}
			--p2;
		}
		if (p1 < D1->n) {
			if (D2->minf == 0) {
				if (a_out2 > b_out2)
					D1->a[p1] = MAX(mlcp2+1, D1->a[p1]);
				else
					D1->a[p1] = MAX(a_out2, D1->a[p1]);
			}
			else {
				D1->a[p1] = MAX(a_out2, D1->a[p1]);
				D1->b[p1] = MIN(b_out2, D1->b[p1]);
			}
		}
		a_out2 = a_out;
		b_out2 = b_out;
		mlcp2 = mlcp;
		mlcp = MIN(mlcp, D1->lcp[p1-1]);
		if (mlcp < a_out) {
			a_out = D1->n+1;
			b_out = 0;
		}
		else
			b_out = MIN(b_out, mlcp);
	}
	fread(&c, 4, 1, inp2);
	assert(c == 0);
	fclose(inp);
	fclose(inp2);
	unlink("merge.txt");
}
